package entity

import "fmt"
import "git.tebibyte.media/sashakoshka/fspl/errors"

// Directive is a declaration within a module metadata file.
type Directive interface {
	directive()
}

// Dependency is a metadata dependency listing.
type Dependency struct {
	Position errors.Position
	Address  Address
	Nickname Nickname
}
func (*Dependency) directive () { }
func (this *Dependency) String () string {
	out := fmt.Sprint("+ ", this.Address)
	if this.Nickname != "" {
		out += fmt.Sprint(" ", this.Nickname)
	}
	return out
}

// Address is the address of a unit.
type Address string
func (addr Address) String () string {
	return Quote(string(addr))
}

// Nickname is the nickname of a unit.
type Nickname string
func (nick Nickname) String () string {
	return string(nick)
}
